<template>
  <div class="m-20 flex justify-center">

    <div
      v-if="userIsLoading"
      class="loading"
    >
      {{ $t('userProfile.loading') }}
    </div>

    <div v-else>
      <div
        v-if="user.data.id === undefined"
        class="user-not-found"
      >
        {{ $t('userProfile.userNotFound', {id}) }}
      </div>

      <div v-else>
        <div
          v-if="isCurrentUser"
          class="flex justify-center"
        >
          <router-link
            :to="{ name: 'profile-settings', params: {id: user.data.id} }"
          >
            <button
              class="ada-button-minor text-sm"
              type="button"
              :title="$t('userProfile.actions.profileEdit')"
            >
              {{ $t('userProfile.actions.profileEdit') }}
            </button>
          </router-link>
        </div>

        <div class="main">
          <div class="picture-layout">
            <img
              :src="user.data.image"
              :alt="$t('userProfile.alt.avatar')"
              class="object-contain h-37.5"
            >
          </div>
          <div class="mt-5 mb-5 flex flex-col overflow-x-auto">
            <div class="ml-6">
              <h4 class="info-name"> {{ user.data.name }} </h4>
              <p class="info-bio">
                {{ user.data.bio }}
              </p>
            </div>
            <div v-if="
              user.data.scratchUsername ||
              user.data.twitterUsername ||
              user.data.instagramUsername ||
              user.data.youtubeUsername ||
              user.data.githubUsername ||
              user.data.cocreaUsername
            ">
              <h6 class="info-medias">{{ $t('userProfile.infoMediaTitle') }}</h6>
              <div class="social-medias">
                <SocialMediaPageUserLink
                  v-for="userSocialMedia in userSocialMedias"
                  :key="userSocialMedia.socialMediaName"
                  v-bind="userSocialMedia"
                />
              </div>
            </div>
          </div>
        </div>

        <div :class="{'trash-projects-zone': showTrash, 'showcase-projects-zone': showShowcase}">
          <h1 class="projects-title">
            <span
              v-if="!showTrash && !showShowcase"
            >
              {{ $t('userProfile.project.title', { userName: user.data.name }) }}<span class="count">({{ isCurrentUser ? allProjectsSum : showcaseProjectsSum }})</span>
            </span>
            <span
              v-if="showShowcase"
            >
              <span class="font-bold"> {{ $t('userProfile.project.showcase.title') }} </span>
                {{ $t('userProfile.project.showcase.content', { userName: user.data.name }) }} <span class="count">({{ showcaseProjectsSum }})</span>
              <p class="text-base pt-2">
                {{ $t('userProfile.project.showcase.text') }}
              </p>
            </span>
            <span
              v-if="showTrash"
            >
              <span class="font-bold"> {{ $t('userProfile.project.trash.title') }} </span>
                {{ $t('userProfile.project.trash.content', { userName: user.data.name }) }} <span class="count">({{ trashProjectsSum }})</span>
            </span>
          </h1>

          <div
            class="mb-10 flex justify-center space-x-6"
            v-if="isCurrentUser"
          >
            <router-link to="/add-project">
              <button
                v-if="!showTrash && !showShowcase"
                class="ada-button"
              >
                {{ $t('userProfile.actions.newProject') }}
              </button>
            </router-link>
            <button
              class="ada-button-minor"
              v-if="!showShowcase && !showTrash"
              :title="$t('userProfile.actions.title.displayShowcase')"
              @click="showShowcase = true"
            >
              {{ $t('userProfile.actions.display.showcase') }}
            </button>
            <button
              class="ada-button"
              v-if="showShowcase && !showTrash"
              :title="$t('userProfile.actions.title.allProjects')"
              @click="showShowcase = false"
            >
              {{ $t('userProfile.actions.display.showcaseList') }}
            </button>
            <button
              class="ada-button-minor"
              v-if="!showTrash && !showShowcase"
              :title="$t('userProfile.actions.title.projectsInTrash')"
              @click="showTrash = true"
            >
              {{ $t('userProfile.actions.display.trash') }}
            </button>
            <button
              class="ada-button"
              v-if="showTrash"
              :title="$t('userProfile.actions.title.notInTrash')"
              @click="showTrash = false"
            >
              {{ $t('userProfile.actions.display.showcaseList') }}
            </button>
          </div>

          <div class="flex justify-center items-center mb-6">
            <label
              class="ada-form-label"
              for="search-bar-query"
            >
              {{ $t('userProfile.project.search') }}
            </label>
            <input
              v-model="searchInput"
              class="ada-text-input"
              id="search-bar-query"
              type="text"
            >
          <button
            v-if="searchingProject"
            class="ada-close-search-button"
            @click="closeSearch"
            :title="$t('userProfile.actions.title.closeSearch')"
          >
            ×
          </button>
          <div
            v-if="searchingProject"
            class="ml-5 ada-projects-found"
          >
            {{ $t('userProfile.project.found', { foundProjectsSum }) }}
          </div>
        </div>
          
        <ListProjectCard
          :projects="projectsList"
          :numberOfItems="numberOfItems"
        />
          
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { computed, ref, watch } from 'vue'
import { useRouter } from 'vue-router'
import { useTitle } from '@vueuse/core'

import { useStore, useUserProjects, useUser } from '../store.js'
import { parseUser } from '../utils'

import SocialMediaPageUserLink from './SocialMediaPageUserLink.vue'
import ListProjectCard from '../components/ListProjectCard.vue'

import scratchLogoUrl from '../assets/scratch.svg'
import twitterLogoUrl from '../assets/twitter-white.svg'
import instagramLogoUrl from '../assets/instagram-white.svg'
import youtubeLogoUrl from '../assets/youtube.svg'
import githubLogoUrl from '../assets/GitHub-Mark-Light-32px.png'
import cocreaLogoUrl from '../assets/cocrea.png'

export default {
  name: 'ThePageUser',
  components: {
    SocialMediaPageUserLink,
    ListProjectCard
  },
  props: {
    id: {
      type: String,
      required: true
    }
  },
  setup (props) {
    const title = useTitle()    
    const router = useRouter()
    const { idIsCurrentUser } = useStore()
    const isCurrentUser = computed(() => idIsCurrentUser(user.id))

    const { user, userIsLoading } = useUser(props.id)
    const { projects: allProjects } = useUserProjects(user);

    const showTrash = ref(false)
    const showShowcase = ref(false)

    // Function that will allow to display projects following different cases
    const projectIsShowable = (project) => {
      if (showTrash.value) {
        // Display current user's trash projects
        return project.data.trash
      } else if (isCurrentUser.value) {
        if (showShowcase.value && !project.data.trash) {
          // Display current user's showcase projects without trash ones
          return project.data.showcase
        } else {
          // Display all current user's project that not are in trash
          return !project.data.trash
        }
      } else if (project.data.showcase && !project.data.trash) {
          // Display only all showcase user's projects without trash ones
          return true
        } else {
          return false
        }
      }

    const showableProjects = computed(() => {
      return allProjects.value.filter(projectIsShowable)
    })

    const searchInput = ref('')
    const searchingProject = computed(() => (
      searchInput.value.length > 0
    ))

    const searchProjects = (project) => {
      if (
        (project.data.name.toLowerCase().includes(searchInput.value.toLowerCase())) ||
        (project.data.abstract.toLocaleLowerCase().includes(searchInput.value.toLowerCase()))
      ) {
        return project.data.name
      } else {
        return false
      }
    }

    const closeSearch = () => {
      searchInput.value = ''
    }

    const projectsFoundOnSearch = computed(() => {
      return showableProjects.value.filter(searchProjects)
    })

    const projectsList = computed(() => {
      if (searchingProject.value) {
        return projectsFoundOnSearch.value
      } else {
        return showableProjects.value
      }
    })

    const allProjectsSum = computed(() => (showableProjects.value.length))

    const showcaseProjectsSum = computed(() => {
      return allProjects.value.filter((project) => project.data.showcase && !project.data.trash).length
    })
    
    const trashProjectsSum = computed(() => {
      return allProjects.value.filter((project) => project.data.trash === true).length
    })

    const foundProjectsSum = computed(() => (projectsFoundOnSearch.value.length))

    // Pagination params: number of items per page
    let numberOfItems = 8

    watch(
      () => user.data,
      (data) => {
        if (data.personalId !== undefined && props.id !== data.personalId) {
          // In that case, we prefer to open the URL with the personalId instead
          // of the faunaId. Reopen the page.
          router.replace(`/people/${data.personalId}`)
        }
      }
    )

    watch(() => user.data.name, (name) => {
      title.value = `${name} on adacraft`
    })

    const encodeString = (string) => {
      return `${encodeURIComponent(string)}`
    }

    const userSocialMedias = computed(() => [
      {
        name: 'Scratch',
        userName: user.data.scratchUsername,
        hoverColor: 'hover:bg-orange-500',
        userHref: `https://scratch.mit.edu/users/${encodeString(parseUser(user.data.scratchUsername))}`,
        src: scratchLogoUrl,
        alt: 'logo scratch',
        width: '15'
      },
      {
        name: 'X',
        userName: user.data.twitterUsername,
        hoverColor: 'hover:bg-black',
        userHref: `https://twitter.com/${encodeString(parseUser(user.data.twitterUsername))}`,
        src: twitterLogoUrl,
        alt: 'logo twitter',
        width: '20'
      },
      {
        name: 'Instagram',
        userName: user.data.instagramUsername,
        hoverColor: 'hover:bg-pink-500',
        userHref: `https://www.instagram.com/${encodeString(parseUser(user.data.instagramUsername))}`,
        src: instagramLogoUrl,
        alt: 'logo instagram',
        width: '20'
      },
      {
        name: 'YouTube',
        userName: user.data.youtubeUsername,
        hoverColor: 'hover:bg-red-600',
        userHref: `https://www.youtube.com/@${encodeString(parseUser(user.data.youtubeUsername))}`,
        src: youtubeLogoUrl,
        alt: 'logo youtube',
        width: '27'
      },
      {
        name: 'GitHub',
        userName: user.data.githubUsername,
        hoverColor: 'hover:bg-gray-800',
        userHref: `https://github.com/${encodeString(parseUser(user.data.githubUsername))}`,
        src: githubLogoUrl,
        alt: 'logo github',
        width: '20'
      },
      {
        name: 'Cocrea (Gandi IDE)',
        userName: user.data.cocreaUsername,
        hoverColor: 'hover:bg-gray-600',
        userHref: `https://cocrea.world/@${encodeString(parseUser(user.data.cocreaUsername))}`,
        src: cocreaLogoUrl,
        alt: 'logo cocrea',
        width: '20'
      }
    ])

    return {
      user,
      userIsLoading,
      isCurrentUser,
      showTrash,
      showShowcase,
      showableProjects,
      searchInput,
      searchingProject,
      closeSearch,
      projectsList,
      allProjectsSum,
      showcaseProjectsSum,
      trashProjectsSum,
      foundProjectsSum,
      numberOfItems,
      parseUser,
      userSocialMedias
    }    
  },
}
</script>

<style lang="postcss" scoped>
.loading {
  @apply dark:text-gray-300;
}

.user-not-found {
  @apply dark:text-gray-300;
}

.main {
  @apply max-w-2xl p-5 m-10 mx-auto;
  @apply flex flex-wrap justify-center md:flex-nowrap;
  @apply bg-white;
  @apply dark:bg-gray-800;
  @apply shadow-lg;
  @apply dark:shadow-gray-900 dark:shadow-xl;
  @apply border border-gray-200 rounded-lg;
  @apply dark:border-gray-700;
}

.picture-layout {
  @apply mb-5 mt-5;
  @apply w-37.5 h-auto;
  @apply flex flex-col justify-center flex-shrink-0;
}

.info-name {
  @apply text-xl leading-tight;
  @apply text-gray-900;
  @apply dark:text-gray-200;
}

.info-bio {
  @apply mt-3;
  @apply whitespace-pre-wrap;
  @apply text-sm leading-normal;
  @apply text-gray-900;
  @apply dark:text-gray-200;
}

.info-medias {
  @apply mt-2 ml-6 text-sm;
  @apply text-gray-500;
  @apply dark:text-gray-400;
}

.social-medias {
  @apply mt-4 ml-6 w-auto; 
  @apply flex flex-row flex-wrap justify-start;
  @apply sm:flex;
}

.projects-title {
  @apply p-10;
  @apply tracking-wider;
  @apply text-center text-2xl text-gray-800;
  @apply dark:text-gray-300;
}

.count {
  @apply text-gray-600;
  @apply dark:text-gray-400;
}

.trash-projects-zone {
  @apply pb-10;
  @apply bg-gray-300;
  @apply dark:bg-gray-900;
  @apply border-gray-200 border rounded-md;
  @apply dark:border-gray-700;
}

.showcase-projects-zone {
  @apply pb-10;
  @apply bg-gray-100;
  @apply dark:bg-gray-600;
  @apply border-gray-200 border rounded-md;
  @apply dark:border-gray-500;
}
</style>